# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

Name:           openxri
Version:        1.2.0
Release:        1%{?dist}
Epoch:          0
Summary:        OpenXRI
License:        ASL 2.0
Group:          Development/Java
URL:            http://www.openxri.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
Source0:        http://downloads.sourceforge.net/project/openxri/openxri-java/1.2.0/openxri-1.2.0-src.tar.gz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch0:         openxri-pom.patch
Patch1:         openxri-XMLUtils.patch

BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-jxr
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  jetty6-maven2-plugins
#BuildRequires:  mojo-maven2-plugin-changelog
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  apache-commons-parent
BuildRequires:  junit

BuildRequires:  apache-commons-logging
BuildRequires:  derby
BuildRequires:  google-guice
BuildRequires:  hibernate3
BuildRequires:  hsqldb
BuildRequires:  icu4j
BuildRequires:  jaf_1_1_api 
BuildRequires:  jta_1_1_api 
BuildRequires:  jug
BuildRequires:  log4j
BuildRequires:  mysql-connector-java
BuildRequires:  servlet_2_5_api
BuildRequires:  slf4j
BuildRequires:  spring2-all
BuildRequires:  wicket
BuildRequires:  wicket-datetime
BuildRequires:  wicket-guice
BuildRequires:  wicket-spring
BuildRequires:  wicket-velocity
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-security

BuildRequires:  java >= 0:1.6.0

Requires:  java >= 0:1.6.0
Requires:  apache-commons-logging
Requires:  google-guice
Requires:  hibernate3
Requires:  icu4j
Requires:  jaf_1_1_api 
Requires:  jta_1_1_api 
Requires:  jug
Requires:  log4j
Requires:  servlet_2_5_api
Requires:  slf4j
Requires:  spring2-all
Requires:  wicket
Requires:  wicket-datetime
Requires:  wicket-guice
Requires:  wicket-spring
Requires:  wicket-velocity
Requires:  xalan-j2
Requires:  xerces-j2
Requires:  xml-security

%description
OpenXRI is an open source project established to develop 
freely redistributable applications and libraries for XRI 
technology as defined by the OASIS XRI Technical Committee. 
Currently, it consists of the following packages:
syntax: An XRI parser library
client: An XRI resolver library
server-logic: A library with the business logic of the 
              server package
server: A web application for running an XRI authority 
        resolution server and/or XRI proxy resolver
admin: A web application for managing an XRI authority 
       resolution server


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:       javamail-javadoc = 0:%{jmailver}

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}-src-%{version}
%patch0 -b .sav0
%patch1 -b .sav1

cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

%build
export CLASSPATH=
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}
export MAVEN_SETTINGS=$(pwd)/settings.xml

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        install 

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Daggregate=true \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 0644 openxri-client/target/openxri-client-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 0644 openxri-server-logic/target/openxri-server-logic-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 0644 openxri-syntax/target/openxri-syntax-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version}||g"`;done)

install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 0644 openxri-admin/target/openxri-admin-1.2.0.war $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 0644 openxri-server/target/openxri-server-1.2.0.war $RPM_BUILD_ROOT%{_datadir}/%{name}

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 openxri-admin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-openxri-admin.pom
%add_to_maven_depmap org.openxri openxri-admin %{version} JPP/%{name} openxri-admin
install -m 644 openxri-client/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-openxri-client.pom
%add_to_maven_depmap org.openxri openxri-client %{version} JPP/%{name} openxri-client
install -m 644 openxri-server-logic/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-openxri-server-logic.pom
%add_to_maven_depmap org.openxri openxri-server-logic %{version} JPP/%{name} openxri-server-logic
install -m 644 openxri-server/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-openxri-server.pom
%add_to_maven_depmap org.openxri openxri-server %{version} JPP/%{name} openxri-server
install -m 644 openxri-syntax/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-openxri-syntax.pom
%add_to_maven_depmap org.openxri openxri-syntax %{version} JPP/%{name} openxri-syntax
install -m 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-openxri.pom
%add_to_maven_depmap org.openxri openxri %{version} JPP/%{name} openxri


# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%{_datadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Fri Jun 10 2011 Ralph Apel <r.apel@r-apel.de> 0:1.2.0-1
- first release

